function whoisinfo(user)
	local vars = {
		name = user.sName,
		ip = user.sIP,
		client = user.iVersion
	}
	local result = replacevars(messages.whoisbasicinfo, vars)
	if user.bOperator then
		local vars = {
			level = ops:getlevel(user.sName),
			privileges = makelist(ops:getprivileges(user.sName))
		}
		result = result..replacevars(messages.whoisopinfo, vars)
	end
	return result
end

function parseuserinfo(info)
	local result
	s, e, name = strfind(info, "%$MyINFO %$ALL (%S+) .*%$ %$.*.%$.*%$%d+%$")
	s, e, desc = strfind(info, "%$MyINFO %$ALL %S+ (.*)%$ %$.*.%$.*%$%d+%$")
	s, e, conn = strfind(info, "%$MyINFO %$ALL %S+ .*%$ %$(.*).%$.*%$%d+%$")
	s, e, email = strfind(info, "%$MyINFO %$ALL %S+ .*%$ %$.*.%$(.*)%$%d+%$")
	s, e, share = strfind(info, "%$MyINFO %$ALL %S+ .*%$ %$.*.%$.*%$(%d+)%$")
	if name and desc and email and conn and share then
		result = {
			name = name,
			description = desc,
			email = email,
			connection = conn,
			share = share
		}
		return result
	end
end

function levelof(user)
	if user.bOperator then
		return ops:getlevel(user.sName)
	else
		return -1
	end
end

function hasprivilege(user, privilege)
	if user.bOperator then
		privileges = ops:getprivileges(user.sName)
		if privileges["*"] then
			return 1
		else
			return privileges[privilege]
		end
	else
		return false
	end
end