dofile("wmBot/debug.lua")

dofile("wmBot/wmLib.lua")
dofile("wmBot/globals.lua")
dofile("wmBot/classes.lua")
dofile("wmBot/helpers.lua")
dofile("wmBot/commands.lua")


function pmrecieved(user, text)
	if installed then
		local success, result
		if strsub(text, 1, 1) == "." then
			local cmd = strsub(text, 2)
			success, result = runcmd(user, cmd)
		else
			success, result = runcmd(user, text)
		end
		if success then
			if result then
				mainbot:pm(user, result)
			end
			return
		end
		for i = 1, getn(modules.items) do
			if modules.items[i].pmrecieved then
				modules.items[i]:pmrecieved(user, text)
			end
		end
	else
		if user.bOperator and strtrim(text) == config.installpw then
			install(user)
		end
		return
	end
end

function chatrecieved(user, text)
	if installed then
		if strsub(text, 1, 1) == "." and strlen(text) > 1 then
			local cmd = strsub(text, 2)
			local success, result = runcmd(user, cmd)
			if success then
				if result then
					mainbot:chatfor(user, result)
				end
				return 1
			end
		end
		for i = 1, getn(modules.items) do
			if modules.items[i].chatrecieved then
				if modules.items[i]:chatrecieved(user, text) then
					-- eat data
					return 1
				end
			end
		end
		return false
	end
	if false then
		if config.capslockwarn then
			local count = 0
			local b
			local min, max = strbyte("A"), strbyte("Z")
			local warn
			for i = 1, strlen(text) do
				b = strbyte(strsub(text, i, i)) 
				if (b >= min) and (b <= max) then
					count = count + 1
				end
				if count >= 3 then
					warn = 1
					break
				end
			end
			if warn then
				if strupper(text) == text then
					local vars = {
						user = user.sName
					}
					mainbot:chat(replacevars(self.messages.capslock, vars))
				end
			end
		end
		local longestkey = ""
		for key, reply in phrases do				
			if strfind(" "..strlower(text).." ", key) then
				if strlen(key) > strlen(longestkey) then
					longestkey = key
				end
			end
		end
		if longestkey ~= "" then
			local reply = self.phrases[longestkey]
			local vars = {
				uzivatel = user.sName
			}
			reply = replacevars(reply, vars)
			self:chat(reply)
		end
	end
	return false
end

function runcmd(user, cmd)
	local s, e, cmdname = strfind(cmd, "(%S+)")
	cmdname = strlower(cmdname)
	arg = strtrim(strsub(cmd, strlen(cmdname) + 2))
	for name, command in commands do
		if name == cmdname then
			return 1, command(user, arg)
		end	
	end
	for i = 1, getn(modules.items) do
		if modules.items[i].command then
			processed, result = modules.items[i]:command(user, cmdname, arg)
			if processed then
				return 1, result
			end
		end
	end
	return false
end

function processchatqueue()
	for i = 1, getn(chatqueue) do
		SendToAll(chatqueue[i].name, chatqueue[i].text)
	end	
	chatqueue = { }
end

function sendwelcome(user)
	local info = parseuserinfo(user.sMyInfoString)
	local vars = {
		user = user.sName,
		hubname = frmHub:GetHubName(),
		wmbot = aboutinfo,
		botname = mainbot.botname,
		users = frmHub:GetUsersCount(),
		maxusers = frmHub:GetMaxUsers(),
		share = format("%.2f", info.share / (1024 * 1024 * 1024))
	}
	local text = replacevars(messages.welcome, vars)
	if config.welcome == 1 then
		mainbot:chatfor(user, text)
	elseif config.welcome == 2 then
		mainbot:pm(user, text)
	end
end

function install(user)
	local item = {
		name = user.sName,
		level = ownerlevel,
		privileges = { ["*"] = 1 }
	}
	ops:add(item)
	owner = ops:count()
	ops:save(path.."ops.dat")
	mainbot:pm(user, messages.ownerset)
	installed = 1
end

function Main()
	randomseed(clock())
	
	SendToAll(" -- running "..aboutinfo.." --");
	mainbot = new_bot(botname)
	mainbot:enter()

	-- load messages in default language
	loadtable(messages, path.."languages/"..deflanguage.."/messages.txt")
	-- load messages
	loadtable(messages, path.."languages/"..config.language.."/messages.txt")

	-- load help in default language
	loadtable(help, path.."languages/"..deflanguage.."/help.txt")
	-- load help
	loadtable(help, path.."languages/"..config.language.."/help.txt")

	modules = new_modulelist()
	for index, value in config.modules do
		dofile(path.."modules/"..value.."/module.lua")

		-- load module-specific messages in default language
		loadtable(messages, path.."modules/"..value.."/languages/"..deflanguage.."/messages.txt")
		-- load module-specific messages
		loadtable(messages, path.."modules/"..value.."/languages/"..config.language.."/messages.txt")

		-- load module-specific help in default language
		loadtable(help, path.."modules/"..value.."/languages/"..deflanguage.."/help.txt")
		-- load module-specific help
		loadtable(help, path.."modules/"..value.."/languages/"..config.language.."/help.txt")
	end
	for i = 1, getn(modules.items) do
		modules.items[i].path = path.."modules/"..modules.items[i].name.."/"
		if modules.items[i].run then
			modules.items[i]:run()
		end
		if modules.items[i].getnewprivileges then
			local newprivileges = modules.items[i]:getnewprivileges()
			for privilege, value in newprivileges do
				possprivileges[privilege] = value
			end
		end
	end

	-- load operator list
	ops = new_optable()
	ops:load(path.."ops.dat")

	installed = (getn(ops.items) > 0)
	if installed then
--		loadphrases()
	end

	-- now override messages with user-specific
	loadtable(messages, path.."messages.txt")
	
	chatqueue = { }

	-- timer!
	SetTimer(1000)
	StartTimer()

	mainbot:chat(messages.done)
	if not installed then
		mainbot:chat(messages.notunlocked)
	end
end

function DataArrival(user, data)
	if strsub(data, 1, 1) == "<" then
		local s, e, text = strfind(data, "%<%S+%> (.*)|.*")
		local eatdata = chatrecieved(user, text)
		if eatdata then
			return 1
		end
		if config.floodprotect == 1 then
			
		end
	elseif strsub(data, 1, 5) == "$To: " then
		local s, e, recipient = strfind(data, "%$To:%s*(%S+)%s*From:")
		if strlower(recipient) == strlower(mainbot.botname) then
			local s, e, msg = strfind(data, "%$To:%s*%S+%s*From:%s*%S+%s*%$%<%S+%> (.*)|.*")
			if msg then
				pmrecieved(user, msg)
				return false
			end
		end
	end
	return false
end

function OnTimer()
	processchatqueue()
end

function NewUserConnected(user)
	if installed then
		if config.welcome > 0 then
			sendwelcome(user)
		end
		for i = 1, getn(modules.items) do
			if modules.items[i].newuserconnected then
				modules.items[i]:newuserconnected(user)
			end
		end
	end
end

function OpConnected(user)
	if installed then
		if config.welcome > 0 then
			sendwelcome(user)
		end
		local vars = {
			name = user.sName
		}
		mainbot:chat(replacevars(messages.opconnected, vars))
		for i = 1, getn(modules.items) do
			if modules.items[i].opconnected then
				modules.items[i]:opconnected(user)
			end
		end
	else
--		mainbot:pm(user, "Detekoval jsem prvni spusteni, pokud jste majitel hubu, poslete mi odblokovaci heslo na PM.")
	end
end

function OpDisconnected(user)
	if installed then
		local vars = { 
			name = user.sName
		}
		mainbot:chat(replacevars(messages.opdisconnected, vars))
		for i = 1, getn(modules.items) do
			if modules.items[i].opdisconnected then
				modules.items[i]:opdisconnected(user)
			end
		end
	end
end