-- wmLib
-- some common functions are defined here

function strtrim(str)
	while strsub(str, 1, 1) == " " do
		str = strsub(str, 2)
		chat(str)
	end
	while strsub(str, strlen(str)) == " " do
		str = strsub(str, 1, strlen(str) - 1)
	end
	return str
end

function parselist(str)
	local curitem = ""
	local result = { }
	local curchar
	for i = 1, strlen(str) do
		curchar = strsub(str, i, i)
		if curchar ~= "," then
			if curchar ~= " " then
				curitem = curitem..curchar
			end
		else
			if curitem ~= "" then
				result[curitem] = 1
				curitem = ""
			end
		end
	end	
	if curitem ~= "" then
		result[curitem] = 1
	end
	return result
end

function makelist(list)
	local result = ""
	for key, value in list do
		if result == "" then
			result = key
		else
			result = result..", "..key
		end
	end
	return result
end

function copytable(table)
	result = { }
	for key, value in table do
		result[key] = value
	end
	return result
end

function replacevars(str, vars)
	for key, value in vars do
		str = gsub(str, "<"..key..">", value)
	end
	return str
end

-- loads string table from file with format:
-- key=value
-- or for multiline values:
-- key={line 1
-- line 2
-- ...
-- line n}
function loadtable(array, filename)
	local file = openfile(filename, "r")
	if file then
		local line = read(file)
		while line do
			-- comment ?
			if strsub(line, 1, 1) ~= "#" then
				local s, e, key = strfind(line, "%s*(%S+)%s*%=.+")
				local s, e, value = strfind(line, "%s*%S+%s*%=(.+)")
				if key and value then
					key = strlower(key)
					value = strtrim(value)
					if strsub(value, 1, 1) == "{" then
						line = strsub(value, 2)
						value = ""
						while line do
							line = strtrim(line)
							if strsub(line, -1) ~= "}" then
								value = value..line
							else
								value = value..strsub(line, 1, strlen(line) - 1)
								break
							end
							value = value.."\013\010"
							line = read(file)
						end
					end
					array[key] = value
				end
			end
			line = read(file)
		end
		closefile(file)
		return 1
	else
		return false
	end
end